'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRockeyHoc = undefined;

var _templateObject = _taggedTemplateLiteral([''], ['']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isString = require('lodash/isString');

var _isString2 = _interopRequireDefault(_isString);

var _isObject = require('lodash/isObject');

var _isObject2 = _interopRequireDefault(_isObject);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _rule = require('rockey/rule');

var _rule2 = _interopRequireDefault(_rule);

var _look = require('./look');

var _look2 = _interopRequireDefault(_look);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var WAS_CALLED_AS_ANONYM_EXTEND = 'WAS_CALLED_AS_ANONYM_EXTEND';
var WAS_CALLED_AS_NAMED_EXTEND = 'WAS_CALLED_AS_NAMED_EXTEND';
var WAS_CALLED_AS_REACT_COMPONENT = 'WAS_CALLED_AS_REACT_COMPONENT';

var getCallType = function getCallType() {
  if (arguments.length === 1 && (0, _isString2.default)(arguments.length <= 0 ? undefined : arguments[0])) {
    return WAS_CALLED_AS_NAMED_EXTEND;
  } else if ((0, _isArray2.default)(arguments.length <= 0 ? undefined : arguments[0]) || (0, _isObject2.default)(arguments.length <= 0 ? undefined : arguments[0]) && arguments.length === 1) {
    return WAS_CALLED_AS_ANONYM_EXTEND;
  } else {
    return WAS_CALLED_AS_REACT_COMPONENT;
  }
};

var anonymysRockeyCounter = 0;
var childCounter = {};

var getRockeyHoc = exports.getRockeyHoc = function getRockeyHoc() {
  var RockeyHoc = function RockeyHoc(BaseComponent) {
    var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        displayName = _ref.displayName,
        parentName = _ref.parentName,
        css = _ref.css;

    var name = displayName || 'AnonymysRockey' + ++anonymysRockeyCounter;
    var queuedMixins = null;

    var FlexibleRockeyHoc = function FlexibleRockeyHoc() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var CALL_TYPE = getCallType.apply(undefined, args);

      switch (CALL_TYPE) {
        // ----
        case WAS_CALLED_AS_NAMED_EXTEND:
          var childComponentName = args[0];

          return function () {
            return RockeyHoc(BaseComponent, {
              displayName: childComponentName,
              css: css
            }).apply(undefined, arguments);
          };

        // ----
        case WAS_CALLED_AS_ANONYM_EXTEND:
          var componentCss = _rule2.default.apply(undefined, args);
          if (css) {
            componentCss.addParent(css);
          }

          if (queuedMixins) {
            componentCss.addMixins(queuedMixins);
          }

          if (!childCounter[name]) {
            childCounter[name] = 0;
          }

          var childName = parentName ? 'Child' + name + '-' + ++childCounter[name] : name;

          componentCss.wrapWith(childName);

          return RockeyHoc(BaseComponent, {
            displayName: childName,
            parentName: name,
            css: componentCss
          });

        // ----
        case WAS_CALLED_AS_REACT_COMPONENT:
          var props = args[0];

          if (!css) {
            // NOTE: mb overdie variable at arguments is not good
            css = (0, _rule2.default)(_templateObject);
            css.wrapWith(name);
          }

          var classList = css.getClassList(props);

          return _react2.default.createElement(BaseComponent, Object.assign({}, props, {
            className: (0, _classnames2.default)(classList[name], props.className)
          }));

        default:
          throw new Error('Wrong component call');
      }
    };

    FlexibleRockeyHoc.displayName = 'Rockey(' + name + ')';

    FlexibleRockeyHoc.extends = function (displayName, childCss) {
      childCss.addParent(css);

      return RockeyHoc(BaseComponent, {
        displayName: displayName,
        parentName: name,
        css: childCss
      });
    };

    FlexibleRockeyHoc.look = function () {
      var component = RockeyHoc(BaseComponent, {
        displayName: displayName,
        parentName: parentName,
        css: css
      });

      return (0, _look2.default)(component, {
        extendBase: false
      }).apply(undefined, arguments);
    };

    FlexibleRockeyHoc.addMixins = function (mixins) {
      if (css) {
        css.addMixins(mixins);
      } else {
        queuedMixins = mixins;
      }
    };

    return FlexibleRockeyHoc;
  };

  return RockeyHoc;
};

var RockeyHoc = getRockeyHoc();
exports.default = RockeyHoc;